dnl ---------------------------------------------------------------------------
dnl Macro: MYSQL_SRC_TEST
dnl ---------------------------------------------------------------------------
AC_DEFUN([MYSQL_SRC_TEST], [
  AC_MSG_CHECKING(for mysql source code)
  AC_ARG_WITH(mysql,
  [[--with-mysql[=mysql source directory] Source required to build engine.]],
  [ENG_MYSQL_SRC="$withval"],
  [ENG_MYSQL_SRC="../.."])
  if test "$ENG_MYSQL_SRC" = "no"; then
    ENG_MYSQL_SRC="../.."
  fi;
  if test -d "$ENG_MYSQL_SRC/sql"; then
    ENG_MYSQL_SRC=`(cd $ENG_MYSQL_SRC && pwd;)`
    AC_DEFINE([ENG_MYSQL_SRC], [1], [Source directory for MySQL])
    ENG_MYSQL_INC="-I$ENG_MYSQL_SRC/sql -I$ENG_MYSQL_SRC/include -I$ENG_MYSQL_SRC/regex -I$ENG_MYSQL_SRC"
    ENG_DRIZZLE_FLAG=""
    MYSQ_SERVER_TYPE="mysql"
    MYSQL_DIR="mysql"
    MYSQ_CLIENT_LIB="mysqlclient_r"
   AC_MSG_RESULT(["$ENG_MYSQL_SRC"])
  else
    if test -d "$ENG_MYSQL_SRC/drizzled"; then
      ENG_MYSQL_SRC=`(cd $ENG_MYSQL_SRC && pwd;)`
      AC_DEFINE([ENG_MYSQL_SRC], [1], [Source directory for MySQL])
      ENG_MYSQL_INC="-I$ENG_MYSQL_SRC"
      ENG_DRIZZLE_FLAG="-DDRIZZLED"
      MYSQL_DIR=""
      MYSQ_SERVER_TYPE="drizzle"
      MYSQ_CLIENT_LIB="drizzle"
     AC_MSG_RESULT(["$ENG_MYSQL_SRC"])
	  else
	   AC_MSG_ERROR(["no MySQL source found at $ENG_MYSQL_SRC"])
     fi
  fi
])

dnl ---------------------------------------------------------------------------
dnl Macro: MYSQL_SRC_TEST
dnl ---------------------------------------------------------------------------

dnl ---------------------------------------------------------------------------
dnl Macro: MYSQL_SRC_CONFIG
dnl ---------------------------------------------------------------------------
AC_DEFUN([MYSQL_SRC_CONFIG], [
  AC_MSG_CHECKING(for mysql configuration settings)
  if test -f $ENG_MYSQL_SRC/config.status ; then
	pbxt_mysql_op=`echo '@exec_prefix@' | ./config.status --file=-`
	if test "x$pbxt_mysql_op" != "x" ; then 
		exec_prefix=$pbxt_mysql_op
	fi	
	pbxt_mysql_op=`echo '@prefix@' | $ENG_MYSQL_SRC/config.status --file=-`
	if test "x$pbxt_mysql_op" != "x" ; then 
		prefix=$pbxt_mysql_op
	fi	
	pbxt_mysql_op=`echo '@libdir@' | $ENG_MYSQL_SRC/config.status --file=-`
	if test "x$pbxt_mysql_op" != "x" ; then 
		libdir=$pbxt_mysql_op
	fi	
	pbxt_mysql_op=`echo '@includedir@' | $ENG_MYSQL_SRC/config.status --file=-`
	if test "x$pbxt_mysql_op" != "x" ; then 
		includedir=$pbxt_mysql_op
	fi	
	pbxt_mysql_op=`echo '@CFLAGS@' | $ENG_MYSQL_SRC/config.status --file=- | sed "s/-g / /" | sed "s/-O[[0-9]]* / /"`
	if test "x$pbxt_mysql_op" != "x" ; then 
		MYSQL_CFLAGS=$pbxt_mysql_op
	else
		MYSQL_CFLAGS=""
	fi	
	pbxt_mysql_op=`echo '@CXXFLAGS@' | $ENG_MYSQL_SRC/config.status --file=- | sed "s/-g / /" | sed "s/-O[[0-9]]* / /"`
	if test "x$pbxt_mysql_op" != "x" ; then 
		MYSQL_CXXFLAGS=$pbxt_mysql_op
	else
		MYSQL_CXXFLAGS=""
	fi	
	
	MYSQL_CONFIGURE_COMMAND=`echo '@CONF_COMMAND@' | $ENG_MYSQL_SRC/config.status --file=-`
  	pbxt_mysql_op=`echo $MYSQL_CONFIGURE_COMMAND| grep "with-debug"`
	if test "x$pbxt_mysql_op" != "x" ; then 
		MYSQL_DEBUG_LEVEL=`echo $pbxt_mysql_op | sed "s/.*--with-debug=//" | sed "s/'.*//"`
	else
		MYSQL_DEBUG_LEVEL="no"
	fi	
	AC_MSG_RESULT(["$prefix"])
 else
    AC_MSG_ERROR(["no config.status found at $ENG_MYSQL_SRC"])
  fi
])

dnl ---------------------------------------------------------------------------
dnl Macro: MYSQL_SRC_CONFIG
dnl ---------------------------------------------------------------------------
