PHP_ARG_ENABLE(pbms,
    [Whether to enable the "pbms" extension],
    [-enable-pbms Enable "pbms" extension support])

# Ask user for path to pbms:.
# pbms may have been installed stand-alone or as part of Drizzle or MySQL
AC_ARG_WITH(mysql,
    [ --with-mysql=<path> prefix of MySQL installation. e.g. /usr/local or /usr],
    [LIB_PATH=$with_mysql/lib/mysql/plugin; INC_PATH=$with_mysql/include/mysql;],
)

AC_ARG_WITH(drizzle,
    [ --with-drizzle=<path> prefix of drizzle installation. e.g. /usr/local or /usr],
    [LIB_PATH=$with_drizzle/lib/; INC_PATH=$with_drizzle/include;],
)

AC_ARG_WITH(pbms,
    [ --with-pbms=<path> prefix of PBMS installation. e.g. /usr/local or /usr],
    [LIB_PATH=$with_pbms/lib/; INC_PATH=$with_pbms/include;],
)

PHP_SUBST(PBMS_PREFIX)

PBMS_LIBS="-L${LIB_PATH}  -lpbmscl"
PHP_SUBST(PBMS_LIBS)

CPPFLAGS="$CPPFLAGS  -I${INC_PATH} -g -Werror ";
LDFLAGS="$LDFLAGS  -g $PBMS_LIBS";

if test $PHP_PBMS != "no"; then
	PHP_SUBST(SAMPLE_SHARED_LIBADD)
	PHP_NEW_EXTENSION(pbms, pbms.c, $ext_shared)
fi
