/* Copyright (c) 2009 PrimeBase Technologies GmbH, Germany
 *
 * PrimeBase Media Stream for MySQL
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Barry Leslie
 *
 * 2009-07-31
 *
 * H&G2JCtL
 *
 * PHP module for the PrimeBase Media Stream (PBMS) daemon.
 *
 */
#ifndef PHP_PBMS_H
	#define PHP_PBMS_H
	#define PHP_PBMS_EXTNAME "pbms"
	#define PHP_PBMS_EXTVER "1.0"
    
    extern zend_module_entry pbms_module_entry;
	#define phpext_pbms_ptr &pbms_module_entry

    #ifdef ZTS
        #include "TSRM.h"
    #endif

	#ifdef HAVE_CONFIG_H
		#include "config.h"
	#endif

	#include <stdlib.h>
	#include <stdio.h>
	#include <unistd.h>
	#include <string.h>
	#include <ctype.h>
	#include <fcntl.h>
	#include <pthread.h>
	#include <dlfcn.h>

ZEND_BEGIN_MODULE_GLOBALS(pbms)
	long debug_mode;
	long display_errors;
	long default_connection_id;
	long num_connections;
	long max_connections;
	long pool_size;
	long default_port;
	char *default_host;
	char *default_database;
ZEND_END_MODULE_GLOBALS(pbms)

    ZEND_MINIT_FUNCTION(pbms);
    ZEND_MSHUTDOWN_FUNCTION(pbms);
    ZEND_RINIT_FUNCTION(pbms);
    ZEND_RSHUTDOWN_FUNCTION(pbms);
    PHP_MINFO_FUNCTION(pbms);

    ZEND_FUNCTION(pbms_connect);
    ZEND_FUNCTION(pbms_close);

	ZEND_FUNCTION(pbms_errno);
    ZEND_FUNCTION(pbms_error);
	
	ZEND_FUNCTION(pbms_put_data);
    ZEND_FUNCTION(pbms_get_data);
    ZEND_FUNCTION(pbms_get_data_range);
	ZEND_FUNCTION(pbms_write_stream);
 	ZEND_FUNCTION(pbms_write_stream_range);
	ZEND_FUNCTION(pbms_read_stream);

	ZEND_FUNCTION(pbms_get_info);

	ZEND_FUNCTION(pbms_is_blob_reference);
    ZEND_FUNCTION(pbms_get_blob_size);

	ZEND_FUNCTION(pbms_add_metadata);
    ZEND_FUNCTION(pbms_clear_metadata);
    ZEND_FUNCTION(pbms_reset_metadata);
    ZEND_FUNCTION(pbms_next_metadata);
    ZEND_FUNCTION(pbms_get_metadata_value);

    ZEND_FUNCTION(pbms_get_md5_digest);

    static zend_function_entry php_pbms_functions[] = {
		ZEND_FE(pbms_errno, NULL)
        ZEND_FE(pbms_error, NULL)
        ZEND_FE(pbms_connect, NULL)
        ZEND_FE(pbms_close, NULL)

        ZEND_FE(pbms_add_metadata, NULL)
        ZEND_FE(pbms_clear_metadata, NULL)
        ZEND_FE(pbms_reset_metadata, NULL)
        ZEND_FE(pbms_next_metadata, NULL)
        ZEND_FE(pbms_get_metadata_value, NULL)

        ZEND_FE(pbms_get_md5_digest, NULL)
        ZEND_FE(pbms_get_info, NULL)

        ZEND_FE(pbms_put_data, NULL)
        ZEND_FE(pbms_get_data, NULL)
		ZEND_FE(pbms_get_data_range, NULL)
        ZEND_FE(pbms_read_stream, NULL)
		ZEND_FE(pbms_write_stream, NULL)
		ZEND_FE(pbms_write_stream_range, NULL)
		ZEND_FE(pbms_is_blob_reference, NULL)
        ZEND_FE(pbms_get_blob_size, NULL)

        {NULL, NULL, NULL}
    };


#endif
