--TEST--
Basic insert BLOB data
--SKIPIF--
<?php if (!extension_loaded("PBMS")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
	// Functions tested:
	// pbms_connect() 
	// pbms_get_data()
	// pbms_write_stream()
	// pbms_close()
	
	include "pbms_utils.php";

	// Connecting, selecting database
	$pbms = pbms_connect($host, $port, $database)
		or pbms_error_and_die("Could not connect");
		

	ini_set("display_errors", "0");
	//$errorlevel=error_reporting();
	//error_reporting($errorlevel & ~E_WARNNING);
	//error_reporting($errorlevel & ~E_ERROR);
	// Check that the error functions work	
	if (pbms_get_data("GARBAGE"))	// This should fail because of a bad BLOB ref.
		printf("Expected error from pbms_get_data(\"GARBAGE\"): %d \n", pbms_errno());
		
	if (pbms_connect($host, 1))	// This should fail because of a bad connection.
		printf("Expected connection failure: %d \n", pbms_errno());
		
	//error_reporting($errorlevel);
	ini_set("display_errors", "1");

	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect");

	print "Connected successfully\n";
	
	init_php_test_database($mysql, $engine, $database);

	mysql_query("Use $database;")
	or mysql_error_and_die("List databases failed");
	
	mysql_query("Delete from test1; ")
		or mysql_error_and_die("Query Failed: $query");

	$data[0] = "A BLOB";
	$data[1] = "This is a some what larger BLOB, but still very tiny by BLOB standards.";
	$data[2] = build_a_char_blob(1024);
	$data[3] = build_a_char_blob(100 * 1024);
	$cnt = 1;
	foreach ($data as $val) {
	
		$query = sprintf ("Insert into test1(c1, c2) values( %d, '%s');", $cnt, $val) ;
		mysql_query($query)
			or mysql_error_and_die("Query Failed: $query");
			
		$cnt++;
	}

	$result = mysql_query("select c1, c2 from test1 order by c1; ")
		or mysql_error_and_die("Query Failed: $query");

	$cnt = 0;
	while ($row = mysql_fetch_assoc($result)) {
		//printf("row(%d): %d, %s\n",  $cnt, $row['c1'], $row['c2']);
		$output = pbms_get_data($row['c2'], $pbms)
			or pbms_error_and_die("pbms_get_data() error");

		//$output .= chr(0);
		if (strcmp($output, $data[$cnt])) {
			printf("Data mismatch in row %d lengths: %d, %d\n", $cnt, strlen($data[$cnt]), strlen($output));
			//printf("Original: -->%s<--\n", $data[$cnt]);
			//printf("Returned: -->%s<--\n", $output);
		}
		
		
		// Test stream access:
		$fh = fopen("phptest.blob", "w+")
			or die("fopen() error");
			
		pbms_write_stream($fh, $row['c2'], $pbms)
			or pbms_error_and_die("pbms_write_stream() error");
		
		rewind($fh);
		$stream_output = "";
		while (!feof($fh))
			$stream_output .= fgets($fh, 4096);
			
		if (strcmp($stream_output, $data[$cnt])) {
			printf("Stream Data mismatch in row %d lengths: %d, %d\n", $cnt, strlen($data[$cnt]), strlen($stream_output));
			//printf("Original: -->%s<--\n", $data[$cnt]);
			//printf("Returned: -->%s<--\n", $output);
		}
		
		fclose($fh);
		unlink("phptest.blob");

		$cnt++;
	}
	
	print "Basic insert BLOB data done.\n";
		
	// Free resultset
	mysql_free_result($result);

	// Closing connection
	pbms_close($pbms);
	mysql_close($mysql);
?>
--EXPECT--
Connected successfully
Basic insert BLOB data done.

