--TEST--
metadata tests
--SKIPIF--
<?php if (!extension_loaded("PBMS")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
	// Functions tested:
	// pbms_connect() 
	// pbms_put_data()
	// pbms_get_data()
	// pbms_add_metadata()
	// pbms_clear_metadata()
	// pbms_reset_metadata()
	// pbms_next_metadata()
	// pbms_get_metadata_value()
	// pbms_close()

	include "pbms_utils.php";

	$metadata[0][0] = "Header1";
	$metadata[0][1] = "PHPTest";
	$metadata[1][0] = "Header2";
	$metadata[1][1] = "Some user defined data";
	$metadata[2][0] = "Header3";
	$metadata[2][1] = "Some meta data ! @ & * % ~ ? < > . : [ ] { } # ( ) + =";
	$metadata[3][0] = "Header1";
	$metadata[3][1] = "PHPTest again";

	function display_header($name) {
		global $metadata;
		$ok = FALSE;
		
		
		if (strcmp($name, "PBMS_LAST_ACCESS") && 
			strcmp($name, "PBMS_CREATION_TIME") && 
			strcmp($name, "PBMS_BLOB_TYPE") && 
			strcmp($name, "PBMS_CHECKSUM") ) {
			
			$ok = ((strncmp($name, "PBMS_", 5) == 0) ||
					(strcmp($name, $metadata[0][0]) == 0) ||
					(strcmp($name, $metadata[1][0]) == 0) ||
					(strcmp($name, $metadata[2][0]) == 0) ||
					(strcmp($name, $metadata[3][0]) == 0));
		}
		
		//print "display_header($name) = $ok\n";
		return $ok;
	}
	

	pbms_connect($host, $port, $database)
		or pbms_error_and_die("Could not connect");
		
	print "Connected successfully\n";
	
	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect");

	init_php_test_database($mysql, $engine, $database);

	mysql_query("Use $database;")
	or mysql_error_and_die("List databases failed");
	
	mysql_query("Delete from test1; ")
		or mysql_error_and_die("Query Failed: $query");

	$my_blob = "A baby BLOB.";
	
	
	// Let PBMS know about our custom headers we want to store with the BLOBs
	resister_my_metadata($mysql, $metadata[0][0]);
	resister_my_metadata($mysql, $metadata[1][0]);
	resister_my_metadata($mysql, $metadata[2][0]);
	
	pbms_add_metadata($metadata[0][0], $metadata[0][1]);
	pbms_add_metadata($metadata[1][0], $metadata[1][1]);
	pbms_add_metadata($metadata[2][0], $metadata[2][1]);
	pbms_add_metadata($metadata[3][0], $metadata[3][1]);
	
	$blob_ref = pbms_put_data($my_blob)
		or pbms_error_and_die("pbms_put_data() error");

	$data = pbms_get_data($blob_ref) // Get the BLOB
		or pbms_error_and_die("pbms_get_data() error");

	if (strcmp($data, $my_blob)) {
		printf("BLOBs are not equal : \"%s\" != \"%s\"\n", $data, $my_blob);
	}
	
	$data = pbms_get_data($blob_ref) // Get it again using the BLOB reference
		or pbms_error_and_die("pbms_get_data() error");

	if (strcmp($data, $my_blob)) {
		printf("BLOBs are not equal : \"%s\" != \"%s\"\n", $data, $my_blob);
	}
	
	//-----------
	// Dump the metadata
	// The position that the checksum appears in te meta data is not constant 
	// so print it seperatly.
	$data = pbms_get_metadata_value("PBMS_CHECKSUM");
	printf( "PBMS_CHECKSUM:%s\n", strtoupper($data));
	$cnt = pbms_reset_metadata(); 
	while ($cnt) {
		$data = pbms_next_metadata();
		if (display_header($data[0]))
			printf(">>%s:%s<<\n", $data[0], $data[1]);
		$cnt--;
	}
		
	//-----------
	//$errorlevel=error_reporting();
	//error_reporting($errorlevel & ~E_WARNNING);
	ini_set("display_errors", "0");
	$data = pbms_next_metadata();
	if (strlen($data[0])) {
		printf("Unexpected metadata >>%s:%s<<\n", $data[0], $data[1]);
	}
	ini_set("display_errors", "1");
	//error_reporting($errorlevel);
	
	//-----------
	$data = pbms_get_metadata_value($metadata[0][0]);
	if (strcmp($data, $metadata[0][1]))
		printf("Incorrect metadata for %s, expected \"%s\" got  \"%s\"\n", $metadata[0][0], $metadata[0][1], $data);
	
	//-----------
	$data = pbms_get_metadata_value($metadata[1][0]);
	if (strcmp($data, $metadata[1][1]))
		printf("Incorrect metadata for %s, expected \"%s\" got  \"%s\"\n", $metadata[1][0], $metadata[1][1], $data);
	
	//-----------
	$data = pbms_get_metadata_value($metadata[2][0]);
	if (strcmp($data, $metadata[2][1]))
		printf("Incorrect metadata for %s, expected \"%s\" got  \"%s\"\n", $metadata[2][0], $metadata[2][1], $data);
	
	//--------------
	// Test that pbms_clear_metadata() works.
	pbms_clear_metadata($metadata[0][0]);
	$blob_ref = pbms_put_data("A BLOB")
		or pbms_error_and_die("pbms_put_data() error");

	$data = pbms_get_data($blob_ref) 
		or pbms_error_and_die("pbms_get_info() error");
		
	// Dump the metadata
	// so print it seperatly.
	$data = pbms_get_metadata_value("PBMS_CHECKSUM");
	printf( "PBMS_CHECKSUM:%s\n", strtoupper($data));
	$cnt = pbms_reset_metadata(); 
	while ($cnt) {
		$data = pbms_next_metadata();
		if (display_header($data[0]))
			printf("\"%s:%s\"\n", $data[0], $data[1]);
		$cnt--;
	}
		
	pbms_clear_metadata();
	$blob_ref = pbms_put_data("An other BLOB")
		or pbms_error_and_die("pbms_put_data() error");

	$data = pbms_get_data($blob_ref) 
		or pbms_error_and_die("pbms_get_info() error");
		
	// Dump the metadata
	// so print it seperatly.
	$data = pbms_get_metadata_value("PBMS_CHECKSUM");
	printf( "PBMS_CHECKSUM:%s\n", strtoupper($data));
	$cnt = pbms_reset_metadata(); 
	while ($cnt) {
		$data = pbms_next_metadata();
		if (display_header($data[0]))
			printf("%s:%s\n", $data[0], $data[1]);
		$cnt--;
	}
		
		
	
	print "metadata tests done.\n";
		
	// Closing connection
	pbms_close();
	mysql_close($mysql);
?>
--EXPECT--
Connected successfully
PBMS_CHECKSUM:AE51D3C40FE471CEF78C8CDAD64B139F
>>PBMS_BLOB_SIZE:12<<
>>PBMS_ACCESS_COUNT:1<<
>>Header1:PHPTest<<
>>Header2:Some user defined data<<
>>Header3:Some meta data ! @ & * % ~ ? < > . : [ ] { } # ( ) + =<<
>>Header1:PHPTest again<<
PBMS_CHECKSUM:68CFA573EEA23B321EE10E4356E5D96F
"PBMS_BLOB_SIZE:6"
"PBMS_ACCESS_COUNT:0"
"Header2:Some user defined data"
"Header3:Some meta data ! @ & * % ~ ? < > . : [ ] { } # ( ) + ="
PBMS_CHECKSUM:DFF7577050928BDFF831EB336D49C966
PBMS_BLOB_SIZE:13
PBMS_ACCESS_COUNT:0
metadata tests done.

