--TEST--
BLOB info tests
--SKIPIF--
<?php if (!extension_loaded("PBMS")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
	// Functions tested:
	// pbms_connect() 
	// pbms_put_data()
	// pbms_get_data()
	// pbms_get_info();
	// pbms_add_metadata()
	// pbms_reset_metadata()
	// pbms_next_metadata()
	// pbms_get_metadata_value()
	// pbms_close()

	include "pbms_utils.php";

	pbms_connect($host, $port, $database)
		or pbms_error_and_die("Could not connect");
		
	print "Connected successfully\n";
	
	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect");

	init_php_test_database($mysql, $engine, $database);

	mysql_query("Use $database;")
	or mysql_error_and_die("List databases failed");
	
	mysql_query("Delete from test1; ")
		or mysql_error_and_die("Query Failed: $query");

	$my_blob = "A baby BLOB.";
	
	$metadata[0][0] = "Header1";
	$metadata[0][1] = "PHPTest";
	$metadata[1][0] = "Header2";
	$metadata[1][1] = "Some user defined data";
	$metadata[2][0] = "Header3";
	$metadata[2][1] = "Some meta data ! @ & * % ~ ? < > . : [ ] { } # ( ) + =";
	
	// Let PBMS know about our custom headers we want to store with the BLOBs
	resister_my_metadata($mysql, $metadata[0][0]);
	resister_my_metadata($mysql, $metadata[1][0]);
	resister_my_metadata($mysql, $metadata[2][0]);
	
	pbms_add_metadata($metadata[0][0], $metadata[0][1]);
	pbms_add_metadata($metadata[1][0], $metadata[1][1]);
	pbms_add_metadata($metadata[2][0], $metadata[2][1]);
	
	$blob_ref = pbms_put_data($my_blob, NULL)
		or pbms_error_and_die("pbms_put_data() error");

	// The checksum is always available after a 'put' or 'get'
	$data = pbms_get_metadata_value("PBMS_CHECKSUM");
	$md5_digest = pbms_get_md5_digest();
	if (strcasecmp($data, bin2hex($md5_digest))) {
		printf("0 bad md5_digest >>%s:%s<<\n", $data, bin2hex($md5_digest));
	}
	printf( "PBMS_CHECKSUM:%s\n", strtoupper($data));
	$data = pbms_get_metadata_value("PBMS_BLOB_TYPE");
	if ($data == "0") { // MS_STANDARD_STORAGE
		//-----------
		pbms_get_info($blob_ref) // Get the BLOB info
			or pbms_error_and_die("pbms_get_data() error");
		$data = pbms_get_metadata_value("PBMS_CHECKSUM");

		if (strcasecmp($data, bin2hex($md5_digest))) {
			printf("1 bad md5_digest >>%s:%s<<\n", $data, bin2hex($md5_digest));
		}
		
		if (strcasecmp($data, md5($my_blob))) {
			printf("1 bad md5 >>%s:%s<<\n", $data, md5($my_blob));
		}

		//-----------
		pbms_get_info($blob_ref) // Get it again using the BLOB reference
			or pbms_error_and_die("pbms_get_data() error");

		$md5_digest = pbms_get_md5_digest();
		$data = pbms_get_metadata_value("PBMS_CHECKSUM");

		if (strcasecmp($data, bin2hex($md5_digest))) {
			printf("2 bad md5_digest >>%s:%s<<\n", $data, bin2hex($md5_digest));
		}
		
		if (strcasecmp($data, md5($my_blob))) {
			printf("2 bad md5 >>%s:%s<<\n", $data, md5($my_blob));
		}
	} else {
		pbms_get_info($blob_ref) // Get the BLOB info
			or pbms_error_and_die("pbms_get_data() error");
	}
	
	//-----------
	// Dump the metadata
	$cnt = pbms_reset_metadata(); 
	while ($cnt) {
		$data = pbms_next_metadata();
		if ((strncmp($data[0], "PBMS_", 5) == 0) || (strncmp($data[0], "Header", 6) == 0)) {
			if (strcmp($data[0], "PBMS_LAST_ACCESS") && 
				strcmp($data[0], "PBMS_CREATION_TIME") && 
				strcmp($data[0], "PBMS_BLOB_TYPE") && 
				strcmp($data[0], "PBMS_CHECKSUM") )
				printf(">>%s:%s<<\n", $data[0], $data[1]);
			}
		$cnt--;
	}
		
	//-----------
	$data = pbms_next_metadata();
	if (strlen($data[0])) {
		printf("Unexpected metadata >>%s:%s<<\n", $data[0], $data[1]);
	}
	
	//-----------
	$data = pbms_get_metadata_value($metadata[0][0]);
	if (strcmp($data, $metadata[0][1]))
		printf("Incorrect metadata for %s, expected \"%s\" got  \"%s\"\n", $metadata[0][0], $metadata[0][1], $data);
	
	//-----------
	$data = pbms_get_metadata_value($metadata[1][0]);
	if (strcmp($data, $metadata[1][1]))
		printf("Incorrect metadata for %s, expected \"%s\" got  \"%s\"\n", $metadata[1][0], $metadata[1][1], $data);
	
	//-----------
	$data = pbms_get_metadata_value($metadata[2][0]);
	if (strcmp($data, $metadata[2][1]))
		printf("Incorrect metadata for %s, expected \"%s\" got  \"%s\"\n", $metadata[2][0], $metadata[2][1], $data);
	
	print "metadata tests done.\n";
		
	// Closing connection
	pbms_close();
	mysql_close($mysql);
?>
--EXPECT--
Connected successfully
PBMS_CHECKSUM:AE51D3C40FE471CEF78C8CDAD64B139F
>>PBMS_BLOB_SIZE:12<<
>>PBMS_ACCESS_COUNT:0<<
>>Header1:PHPTest<<
>>Header2:Some user defined data<<
>>Header3:Some meta data ! @ & * % ~ ? < > . : [ ] { } # ( ) + =<<
metadata tests done.

