--TEST--
Async PBMS repository backup test.
--SKIPIF--
<?php print "skip: This is a long running test and should be run by itself."; ?>
--POST--
--GET--
--FILE--
<?php 
	include "pbms_utils.php";

	
	global $cloud_ref;
	
	print "Async PBMS repository backup test:\n";
	
	if ($mysqlServerInst == "")
		die("This test requires the path to the mysql server installation and the privileges to stop and start it.\n");
		
	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect\n");

	// Get the path to the databases dir. I am assuming it is on this machine and I 
	// can access it directly.
	$query = "SELECT variable_value FROM information_schema.GLOBAL_VARIABLES  where variable_name = 'DATADIR'";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query ");
	$row = mysql_fetch_row($result);
	$db_path = $row[0];
	mysql_free_result($result);

	if (!is_writable($db_path)) {
		die("This test requires write access to $db_path");
	}

	init_load_test($mysql, $engine, $database);

	mysql_query("Use $database;")
		or mysql_error_and_die("Use $database; failed\n");

	//--------------------
	$loaddata = "php -c pbms_php_test.ini -f tests/LoadData.php -d extension_dir=modules/ -d extension=pbms.so";
	for ($i = 0; $i < 3; $i++) {
		$procs[] = proc_open($loaddata, array(), $pipes)
			or die("proc_open() failed");
	}

	$runnung = TRUE;
	while ($runnung) {
		sleep(1);
		$runnung = FALSE;
		for ($i = 0; $i < 3; $i++) {
			$status = proc_get_status($procs[$i])
				or die("proc_get_status() failed");
				
			if ($status["running"])
				$runnung = TRUE;
		}
		
	}

	$db_path .= "pbms/";
	
	$dir = scandir($db_path)
		or die("scandir() failed.\n");
	
	$pbms_db_path = "";
	$dbname = strtolower($database); 
	foreach( $dir as $d ){ 
		$d = basename($d);
		if (sscanf(strtolower($d), "$dbname-%d%s", $id, $junk) == 1) {
			$pbms_db_path = $db_path . "/" .$d;
			$pbms_backup = "backups/pbms/$d";
			break;
		}
	}
	
	if ($pbms_db_path == "") {
		die("Could not find PBMS database $backupdb in location $db_path\n");
	}
	 
	// Backup the BLOB repository while a script is running that will update the BLOBs.
	// The backed up repository should match the pre backup version with out any of the 
	// changes that took place during the backup.
	if (! is_dir("backups"))
		mkdir("backups");
	elseif (is_dir($pbms_backup))
		system("rm -r $pbms_backup");
		
	$mybackup = 19836;
	$query = "delete from pbms.pbms_backup where id = $mybackup";
	mysql_query($query)
	or mysql_error_and_die("Query Failed: $query");
	
	print "Starting backup\n";
	$cwd = getcwd();
	$query = "insert into pbms.pbms_backup(Id, Database_Name, Location, Cloud_Ref)  values($mybackup, '$database', '$cwd/backups', $cloud_ref)";
	mysql_query($query)
	or mysql_error_and_die("Query Failed: $query");

	$query = "select id from pbms.pbms_backup  where id = $mybackup AND isRunning = 'yes' ";
	do {		
		$result = mysql_query($query)
			or mysql_error_and_die("Query Failed: $query ");
			
		$rows = mysql_num_rows($result);
		mysql_free_result($result);	
		if ($rows > 0)
			sleep(1);
	} while ($rows > 0) ;
	
	$query = "select Completed from pbms.pbms_backup  where id = $mybackup";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query ");
		
	$row = mysql_fetch_array($result);
	if (is_null($row[0])) {
		die("Backup Failed\n");
	}
	mysql_free_result($result);	
	 
	print "Backup Completed\n";

// To test our backup we are going to shutdown the MySQL server amd replace
// the repository in it with the backup we just made. Then the server is restarted and
// the content will be verified.	
	
	print "Shutting down the MySQL database server!\n";
	
	$cmd = "$mysqlServerInst/bin/mysqladmin   -u $mysql_user --password=$mysql_passwd shutdown";
	//print "Executing command: $cmd \n";
	system($cmd);
	print "MySQL database server has been shutdown.\n";
	
	//system("rm -r $pbms_db_path");
	$xx = $pbms_db_path . "xx";
	system("mv $pbms_db_path $xx");
	rename($pbms_backup, $pbms_db_path);
	
	mysql_close($mysql);

	print "Restarting the MySQL database server!\n";
	$cmd = "$mysqlServerInst/bin/mysqld_safe   --basedir=$mysqlServerInst  --pbms_temp_blob_timeout=600 > /$mysqlServerInst/var/mysql_error.log 2>&1 &";
	//print "Executing command: $cmd \n";
	system($cmd);
	print "MySQL database server has been restarted. (I hope.)\n";
	
	$cnt = 10;
	while (TRUE) {
		sleep(2); // Give it a little time to get started.	
		if ( mysql_connect(ini_get("mysql.default_host"), ini_get("mysql.default_user"), ini_get("mysql.default_password"), TRUE) != FALSE)
			break;
		//printf("%s\n", mysql_error()); 
		$cnt--;
		if ($cnt == 0)
			die("Cannot reconnect to the server.\n");
	}
	
	include "CheckData.php";
	
	print "Async PBMS repository backup test done.\n";
?>
--EXPECT--
Async PBMS repository backup test:

Load database:
Load database:
Load database:
Load database done.

Load database done.

Load database done.

Starting backup
Backup Completed
Shutting down the MySQL database server!
MySQL database server has been shutdown.
Restarting the MySQL database server!
MySQL database server has been restarted. (I hope.)
Check data:
Check data done.

Async PBMS repository backup test done.
