--TEST--
Test getting partial BLOBs using the range header.
--SKIPIF--
<?php if (!extension_loaded("PBMS")) print "skip: This test should be run by itself."; ?>
--POST--
--GET--
--FILE--
<?php 
	include "pbms_utils.php";

	
	print "Test getting partial BLOBs using the range header:\n";
	
	//------------------------------------------------------
	function rangetest($blob_ref, $first, $last)
	{
		$fileName = "rangetest.blob";
		
		// Test stream access:
		$fh = fopen($fileName, "w+")
			or die("fopen() error");
			
		pbms_write_stream_range($fh, $blob_ref, $first, $last)
			or pbms_error_and_die("pbms_write_stream_range() error");
		
		fclose($fh);
		$fh = fopen($fileName, "r")
			or die("fopen() error");
		
		$str1 = fread($fh, 100);
		fclose($fh);
		unlink($fileName);
		
		printf("Streamed Range %d-%d: -->%s<--\n", $first, $last, $str1);

	}

	pbms_connect($host, $port, $database)
		or pbms_error_and_die("Could not connect\n");
		
	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect\n");

	print "Connected successfully\n";
	init_php_test_database($mysql, $engine, $database);
	
	mysql_query("Use $database;")
	or mysql_error_and_die("Use $database  failed\n");
	
	if (mysql_query("Delete from test1; ") == FALSE) {
		mysql_error_and_die("Delete from test1 Failed: \n");
	}

	$myTestData = "Test getting partial BLOBs using the range header:";
	$blob_size = strlen($myTestData);

	$blob_ref = pbms_put_data($myTestData)
		or pbms_error_and_die("pbms_put_data() error");
	
	//----	
	$first = 0;
	$last = $blob_size + 10;
	$output = pbms_get_data_range($blob_ref, $first, $last)
			or pbms_error_and_die("pbms_get_data_range() error ");
			
	printf("Range %d-%d: -->%s<--\n", $first, $last, $output);

	//----	
	$first = 0;
	$last = 9;
	$output = pbms_get_data_range($blob_ref, $first, $last)
			or pbms_error_and_die("pbms_get_data_range() error ");
			
	printf("Range %d-%d: -->%s<--\n", $first, $last, $output);

	//----	
	$first = 10;
	$last = 19;
	$output = pbms_get_data_range($blob_ref, $first, $last)
			or pbms_error_and_die("pbms_get_data_range() error ");
			
	printf("Range %d-%d: -->%s<--\n", $first, $last, $output);

	//----	
	$first = $blob_size -10;
	$last = $blob_size -1;
	$output = pbms_get_data_range($blob_ref, $first, $last)
			or pbms_error_and_die("pbms_get_data_range() error ");
			
	printf("Range %d-%d: -->%s<--\n", $first, $last, $output);


	//----	
	$first = $blob_size -5;
	$last = $blob_size +5;
	$output = pbms_get_data_range($blob_ref, $first, $last)
			or pbms_error_and_die("pbms_get_data_range() error ");
			
	printf("Range %d-%d: -->%s<--\n", $first, $last, $output);

	//----	
	$first = 0;
	$last = 0;
	$output = pbms_get_data_range($blob_ref, $first, $last)
			or pbms_error_and_die("pbms_get_data_range() error ");
			
	printf("Range %d-%d: -->%s<--\n", $first, $last, $output);

	//----	
	$first = $blob_size -1;
	$last = $blob_size -1;
	$output = pbms_get_data_range($blob_ref, $first, $last)
			or pbms_error_and_die("pbms_get_data_range() error ");
			
	printf("Range %d-%d: -->%s<--\n", $first, $last, $output);

	// Do the same tests using pbms_write_range()
	
	//----	
	$first = 0;
	$last = $blob_size + 10;
	rangetest($blob_ref, $first, $last);

	//----	
	$first = 0;
	$last = 9;
	rangetest($blob_ref, $first, $last);

	//----	
	$first = 10;
	$last = 19;
	rangetest($blob_ref, $first, $last);

	//----	
	$first = $blob_size -10;
	$last = $blob_size -1;
	rangetest($blob_ref, $first, $last);

	//----	
	$first = $blob_size -5;
	$last = $blob_size +5;
	rangetest($blob_ref, $first, $last);

	//----	
	$first = 0;
	$last = 0;
	rangetest($blob_ref, $first, $last);

	//----	
	$first = $blob_size -1;
	$last = $blob_size -1;
	rangetest($blob_ref, $first, $last);


	
	print "Test getting partial BLOBs using the range header done.\n";
?>
--EXPECT--
Test getting partial BLOBs using the range header:
Connected successfully
Range 0-60: -->Test getting partial BLOBs using the range header:<--
Range 0-9: -->Test getti<--
Range 10-19: -->ng partial<--
Range 40-49: -->ge header:<--
Range 45-55: -->ader:<--
Range 0-0: -->T<--
Range 49-49: -->:<--
Streamed Range 0-60: -->Test getting partial BLOBs using the range header:<--
Streamed Range 0-9: -->Test getti<--
Streamed Range 10-19: -->ng partial<--
Streamed Range 40-49: -->ge header:<--
Streamed Range 45-55: -->ader:<--
Streamed Range 0-0: -->T<--
Streamed Range 49-49: -->:<--
Test getting partial BLOBs using the range header done.

