--TEST--
Test if update only updates BLOBs that have changed.
--SKIPIF--
<?php if (!extension_loaded("PBMS")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
	include "pbms_utils.php";

	print "Test if update only updates BLOBs that have changed.\n";
	pbms_connect($host, $port, $database)
		or pbms_error_and_die("Could not connect");

	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect");
	
	init_php_test_database($mysql, $engine, $database);
	mysql_query("Use $database;")
	or mysql_error_and_die("Use $database failed");
	
	$query = sprintf ("Create table IF NOT EXISTS updatetest (c1 int, c2 longblob, c3 longblob, c4 longblob) ENGINE = %s;", $engine);
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("$query Failed\n");
	}

	$query = "Delete from updatetest;";
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("$query Failed\n");
	}

	$blob_ref1 = pbms_put_data("A new BLOB", "updatetest")
		or pbms_error_and_die("pbms_write_stream() error");

	$blob_ref2 = pbms_put_data("A Different BLOB", "updatetest")
		or pbms_error_and_die("pbms_write_stream() error");

	$query = sprintf ("Insert into updatetest(c1, c2, c4) values(1, '%s', '%s');", $blob_ref1, $blob_ref2) ;
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("Query Failed: $query\n");
	}

	$blob_id2 = getBlobID(1, "updatetest", "c2", $mysql);
	$blob_id4 = getBlobID(1, "updatetest", "c4", $mysql);
			
	$query = "select * from updatetest where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	$Blob_url2 = $row['c2'];
	$Blob_url4 = $row['c4'];

	//----------
	print "Update just the id column.\n";
	$query = "update updatetest set c1 = 2 where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");

	
	$query = "select * from updatetest where c1 = 2;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	if (($Blob_url2 != $row['c2']) || ($Blob_url4 != $row['c4']) )
		die("BLOB URL was changed unexpectedly in update.\n");
		
	testBlobStatus($mysql, $blob_id2, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id4, "updatetest", TRUE);
		
	//----------
	print "Update just the NULL blob column.\n";
	$query = "update updatetest set c3 = 'A NULL BLOB update.' where c1 = 2;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
		
	$blob_id3 = getBlobID(2, "updatetest", "c3", $mysql);

	$query = "select * from updatetest where c1 = 2;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	if (($Blob_url2 != $row['c2']) || ($Blob_url4 != $row['c4']) )
		die("BLOB URL was changed unexpectedly in update.\n");

	$Blob_url3 = $row['c3'];

	testBlobStatus($mysql, $blob_id2, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id3, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id4, "updatetest", TRUE);
		
	//----------
	print "Update the first blob column.\n";
	$query = "update updatetest set c2 = 'A New BLOB.' where c1 = 2;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
		
	testBlobStatus($mysql, $blob_id2, "updatetest", FALSE);

	$blob_id2 = getBlobID(2, "updatetest", "c2", $mysql);

	$query = "select * from updatetest where c1 = 2;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	if (($Blob_url2 == $row['c2']) || ($Blob_url3 != $row['c3']) || ($Blob_url4 != $row['c4']) )
		die("BLOB URL was changed unexpectedly in update.\n");

	$Blob_url2 = $row['c2'];

	testBlobStatus($mysql, $blob_id2, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id3, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id4, "updatetest", TRUE);
		
	//----------
	print "Update the last 2 blob columns.\n";
	$query = "update updatetest set c3 = 'A New BLOB 1.', c4 = 'A New BLOB 2.' where c1 = 2;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
		
	testBlobStatus($mysql, $blob_id3, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id4, "updatetest", FALSE);

	$blob_id3 = getBlobID(2, "updatetest", "c3", $mysql);
	$blob_id4 = getBlobID(2, "updatetest", "c4", $mysql);

	$query = "select * from updatetest where c1 = 2;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	if (($Blob_url2 != $row['c2']) || ($Blob_url3 == $row['c3']) || ($Blob_url4 == $row['c4']) )
		die("BLOB URL was changed unexpectedly in update.\n");

	$Blob_url3 = $row['c3'];
	$Blob_url4 = $row['c4'];

	testBlobStatus($mysql, $blob_id2, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id3, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id4, "updatetest", TRUE);
		
	$query = "delete from updatetest; ";
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("Query Failed: query\n");
	}

	testBlobStatus($mysql, $blob_id2, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id3, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id4, "updatetest", FALSE);
		

	print "Looks good.\n";
?>
--EXPECT--
Test if update only updates BLOBs that have changed.
Update just the id column.
Update just the NULL blob column.
Update the first blob column.
Update the last 2 blob columns.
Looks good.


