--TEST--
Test NULL and zero length BLOBs.
--SKIPIF--
<?php if (!extension_loaded("PBMS")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
	include "pbms_utils.php";

	print "Test NULL and zero length BLOBs.\n";
	pbms_connect($host, $port, $database)
		or pbms_error_and_die("Could not connect");

	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect");
	
	init_php_test_database($mysql, $engine, $database);
	mysql_query("Use $database;")
	or mysql_error_and_die("Use $database failed");
	
	// By actually dropping the table I remove any old unreferenced BLOBs
	// associated with it from pbms_reference.
	$query = "Drop table IF EXISTS updatetest;";
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("$query Failed\n");
	}

	$query = sprintf ("Create table IF NOT EXISTS updatetest (c1 int, c2 longblob, c3 longblob, c4 longblob) ENGINE = %s;", $engine);
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("$query Failed\n");
	}

	$blob_ref1 = pbms_put_data("A new BLOB", "updatetest")
		or pbms_error_and_die("pbms_write_stream() error");

	$blob_ref2 = pbms_put_data("A Different BLOB", "updatetest")
		or pbms_error_and_die("pbms_write_stream() error");

	$blob_ref3 = pbms_put_data("A BLOB Update", "updatetest")
		or pbms_error_and_die("pbms_write_stream() error");

	$query = sprintf ("Insert into updatetest(c1, c2, c4) values(1, '%s', '%s');", $blob_ref1, $blob_ref2) ;
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("Query Failed: $query\n");
	}

	$blob_id2 = getBlobID(1, "updatetest", "c2", $mysql);
	$blob_id4 = getBlobID(1, "updatetest", "c4", $mysql);
			
	$query = "select * from updatetest where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	$Blob_url2 = $row['c2'];
	$Blob_url4 = $row['c4'];

	if (is_null($row['c3']) == FALSE)
		die("Expeceted NULL BLOB.\n");
		
	//----------
	print "Update a NULL BLOB column.\n";
	$query = sprintf ("update updatetest set c3 = '%s' where c1 = 1;", $blob_ref3) ;
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");

	
	$query = "select * from updatetest where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	if (($Blob_url2 != $row['c2']) || ($Blob_url4 != $row['c4']) )
		die("BLOB URL was changed unexpectedly in update.\n");
		
	$Blob_url3 = $row['c3'];
	if (is_null($Blob_url3))
		die("Unexpeceted NULL BLOB.\n");
		

	$blob_id3 = getBlobID(1, "updatetest", "c3", $mysql);

	testBlobStatus($mysql, $blob_id2, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id3, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id4, "updatetest", TRUE);
		
	//----------
	print "Update a BLOB setting it to NULL.\n";
	$query = "update updatetest set c3 = NULL where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
		
	testBlobStatus($mysql, $blob_id2, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id3, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id4, "updatetest", TRUE);

	$query = "select * from updatetest where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	if (($Blob_url2 != $row['c2']) || ($Blob_url4 != $row['c4']) )
		die("BLOB URL was changed unexpectedly in update.\n");

	if (is_null($row['c3']) == FALSE)
		die("Expeceted NULL BLOB.\n");
		
	//----------
	print "Update 2 blob columns setting one to NULL and the other to non NULL.\n";
	$query = "update updatetest set c3 = 'A New BLOB.', c2 = NULL where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
		
	$blob_id3 = getBlobID(1, "updatetest", "c3", $mysql);

	$query = "select * from updatetest where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	if ($Blob_url4 != $row['c4']) 
		die("BLOB URL was changed unexpectedly in update.\n");

	$Blob_url3 = $row['c3'];
	
	if (is_null($row['c2']) == FALSE)
		die("Expeceted NULL BLOB.\n");
		

	testBlobStatus($mysql, $blob_id2, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id3, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id4, "updatetest", TRUE);
		
	//----------
	print "Set blob columns to zero length BLOBs.\n";
	$query = "update updatetest set c2 = '', c4 = '' where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
		
	testBlobStatus($mysql, $blob_id2, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id3, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id4, "updatetest", FALSE);

	$blob_id2 = getBlobID(1, "updatetest", "c2", $mysql);
	$blob_id4 = getBlobID(1, "updatetest", "c4", $mysql);

	$query = "select * from updatetest where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	if ($Blob_url3 != $row['c3']) 
		die("BLOB URL was changed unexpectedly in update.\n");

	$Blob_url2 = $row['c2'];
	$Blob_url4 = $row['c4'];

	testBlobStatus($mysql, $blob_id2, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id3, "updatetest", TRUE);
	testBlobStatus($mysql, $blob_id4, "updatetest", TRUE);
	
	if (pbms_get_blob_size($Blob_url2) > 0)
		die("Unexpected none zero BLOB size.\n");
		
	if (pbms_get_blob_size($Blob_url4) > 0)
		die("Unexpected none zero BLOB size.\n");
		
	//----------
	print "Using update set ALL blob columns to NULL.\n";
	$query = "update updatetest set c2 = NULL, c3 = NULL, c4 = NULL where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
		
	testBlobStatus($mysql, $blob_id2, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id3, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id4, "updatetest", FALSE);


	$query = "select * from updatetest where c1 = 1;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result)
		or mysql_error_and_die("No row was returned: $query");

	if ((is_null($row['c2']) == FALSE) || (is_null($row['c3']) == FALSE) || (is_null($row['c4']) == FALSE))
		die("Expeceted NULL BLOB.\n");
		

	$query = "delete from updatetest; ";
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("Query Failed: query\n");
	}

	testBlobStatus($mysql, $blob_id2, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id3, "updatetest", FALSE);
	testBlobStatus($mysql, $blob_id4, "updatetest", FALSE);
		

	print "Looks good.\n";
?>
--EXPECT--
Test NULL and zero length BLOBs.
Update a NULL BLOB column.
Update a BLOB setting it to NULL.
Update 2 blob columns setting one to NULL and the other to non NULL.
Set blob columns to zero length BLOBs.
Using update set ALL blob columns to NULL.
Looks good.


