<?php 
	//==================================================
	$backup_test_rows = 100;
	$s3_server = "";
	$s3_bucket = "";
	$s3_public_key = "";
	$s3_private_key = "";
	$cloud_ref = 87;
	// Common default setings:
	include "custom_settings.ini";
	
	//------------------------------------------------------
	function mysql_error_and_die($msg)
	{
		printf("MySQL ERROR: %s\n", mysql_error());
		die("$msg\n");
	}
	
	//------------------------------------------------------
	function pbms_error_and_die($msg)
	{
		printf("PBMS ERROR: %s\n", pbms_error());
		die("$msg\n");
	}
	
	//------------------------------------------------------
	function set_cloud_storage()
	{
		global $cloud_ref, $s3_server, $s3_public_key, $s3_private_key, $s3_bucket;

		if (empty($s3_server)) {
			print "Could not set cloud data, s3_server is not set.\n";
			return;
		}

		if (empty($s3_public_key)) {
			print "Could not set cloud data, s3_public_key is not set.\n";
			return;
		}

		if (empty($s3_private_key)) {
			print "Could not set cloud data, s3_private_key is not set.\n";
			return;
		}

		if (empty($s3_bucket)) {
			print "Could not set cloud data, s3_bucket is not set.\n";
			return;
		}

		
		
		$query = "select id from  pbms.pbms_cloud where id = $cloud_ref";
		$result = mysql_query($query)
			or mysql_error_and_die("Query Failed: $query");

		if ( mysql_num_rows($result) == 0) {
			$query = "insert into pbms.pbms_cloud VALUES($cloud_ref, '$s3_server', '$s3_bucket', '$s3_public_key', '$s3_private_key')";
			mysql_query($query)
				or mysql_error_and_die("Query Failed: $query");
		}
		
		$query = "update pbms_variable set value = 'CLOUD' where Name = 'Storage-type'";
		mysql_query($query)
			or mysql_error_and_die("Query Failed: $query");

		$query = "update pbms_variable set value = $cloud_ref where Name = 'S3-Cloud-Ref'";
		mysql_query($query)
			or mysql_error_and_die("Query Failed: $query");

	}
	

	//------------------------------------------------------
	function build_a_blob($size)
	{
	
		$str = "";
		while ($size > 0) {
			$str .=  chr($size%256);
			$size--;
		}
		return $str;
	}

	//------------------------------------------------------
	function build_a_char_blob($size)
	{
		// I am building the blob with printable characters for debugging
		// puposes and to make working with them in PHP easier. 
		// It is not a limitation of PBMS BLOBs.
		$str = "";
		while ($size > 0) {
			$str .=  chr($size%26 + 65);
			$size--;
		}
		return $str;
	}

	//------------------------------------------------------
	function create_a_blob($no, $str)
	{
	
		$name = sprintf("004TestBolb%d.blob", $no);
		$fh = fopen($name, "w+")
			or die("fopen() error" + $name);
		fwrite($fh, $str)
			or die("fwrite() error");
		fclose($fh);
		return $name;
	}


	//------------------------------------------------------
	function create_a_big_blob($no, $size)
	{
		$data = build_a_blob(1024);
		
		$name = sprintf("004TestBolb%d.blob", $no);
		$len = 1024;
		$fh = fopen($name, "w+")
			or die("fopen() error");

		while ($size) {
			if ($size < 1024)
				$len =$size;
				
			$size -= $len;
			fwrite($fh, $data, $len)
				or die("fwrite() error");
		}
		
		fclose($fh);
		return $name;
	}


	//------------------------------------------------------
	function compare_blob_files($file1, $file2)
	{
		$ok = TRUE;
		$size = filesize($file1);
		$output = array();
		$rtc = "";

		exec("cmp $file1 $file2", $output, $rtc);
		if ($rtc == 0)
			return TRUE;
	
		if ($size != filesize($file2)) {
			printf("File size error: %s(%d) != %s(%d)\n",$file1, $size,$file2, filesize($file2));
			$ok = FALSE;
		} else {
			$fh1 = fopen($file1, "r")
				or die("fopen() error");
				
			$fh2 = fopen($file2, "r")
				or die("fopen() error");
			$len = 1024;
			$pos = 0;
			while ($size) {
				if ($size < 1024)
					$len =$size;
				$size -= $len;
					
				$str1 = fread($fh1, $len);
				$str2 = fread($fh2, $len);
				
				if (strcmp($str1, $str2)) {
					$ok = FALSE;
					printf("File data not equal around position %d\n", $file1, $file2, $pos);
					//printf("str1: -->%s<--\n", $str1);
					//printf("str2: -->%s<--\n", $str2);
					$size = 0;
				}
				$pos += $len;				
			}
			
			fclose($fh1);
			fclose($fh2);
		}
		
		return $ok;
	}
	

	//------------------------------------------------------
	function resister_my_metadata($mysql, $header)
	{
		$query = sprintf ("select Name from pbms_metadata_header where Name = '%s';", $header) ;
		//printf("%s\n", $query);
		$result = mysql_query($query)
			or mysql_error_and_die("Query Failed: $query");
			
		if (mysql_num_rows($result) == 0) {	
			$query = sprintf ("insert into pbms_metadata_header(Name) Values('%s');", $header) ;
			mysql_query($query)
				or mysql_error_and_die("Query Failed: $query" );
		}
			
		mysql_free_result($result);		
	}
	
	//------------------------------------------------------
	function load_backup_test_data()
	{
		global $backup_test_rows;
		
		$cnt = 1;
		while ($cnt <= $backup_test_rows) {
			$val = build_a_char_blob($cnt +100);
			$blob_ref = pbms_put_data($val)
				or pbms_error_and_die("pbms_put_data() failed");
			mysql_query("insert into test1(c1, c2, c3) values($cnt, \"$blob_ref\", \"$val\")")
			or mysql_error_and_die("mysql_query() failed");
			$cnt++;
		}
	}

	//------------------------------------------------------
	function verify_backup_test_data()
	{
		global $backup_test_rows;
		$result = mysql_query("select c1, c2, c3 from test1")
			or mysql_error_and_die("mysql_query() failed");
		
		$rowcnt = mysql_num_rows($result);
		if ($rowcnt != $backup_test_rows) {
			printf("Unexpected number of rows: expected %d found %d\n", $backup_test_rows, $rowcnt);
		}
		
		while ($row = mysql_fetch_array($result)) {
			$blob = pbms_get_data($row[1])
				or pbms_error_and_die("pbms_get_data($row[1]) failed\n");
				
			if (strcmp($blob, $row[2])) {
				printf("Backup data not equal in row %d\n", $row[0]);
				printf("blob: -->%s<--\n", $blob);
				printf("data: -->%s<--\n", $row[2]);
				return;
			}
		}
		mysql_free_result($result);
	}


	//------------------------------------------------------
	function init_php_test_database($mysql, $engine, $database)
	{
		// List databases.
		$result = mysql_list_dbs($mysql)
		or mysql_error_and_die("List databases failed");

		$rows = mysql_num_rows($result);
		$fields = mysql_num_fields($result);
		
		//print "List databases successfull Rows: $rows, Fields: $fields \n";
		
		//========== Create database if required. ===========================	
		$test_db_found = 0;
		// Printing results
		while ($line = mysql_fetch_array($result, 1)) {
			foreach ($line as $col_value) {
				if ( $col_value == $database ) 
					$test_db_found = 1;
			}
		}
		
		// Free result set
		mysql_free_result($result);

		if ( $test_db_found == 0 ) {
	
			mysql_query("create database $database;", $mysql)
				or mysql_error_and_die("Could not create test database");
				
			mysql_query("Use $database;", $mysql)
				or mysql_error_and_die("Use $database; failed\n");

			global $s3_server;
			if (! empty($s3_server)) 
				set_cloud_storage();
		}
		
		
		/* Open the database. */
		mysql_select_db($database, $mysql)
			or mysql_error_and_die("Open dataabse failed");
		
		$query = "use  $database;";
		if (mysql_query($query, $mysql) == FALSE) {
			mysql_error_and_die("$query Failed\n");
		}

		$query = "Drop table IF EXISTS test1;";
		if (mysql_query($query, $mysql) == FALSE) {
			mysql_error_and_die("$query Failed\n");
		}

		$query = "Drop table IF EXISTS test2;";
		if (mysql_query($query, $mysql) == FALSE) {
			mysql_error_and_die("$query Failed\n");
		}

		//========== Create test1 table if required. ===========================	
		$query = sprintf("CREATE TABLE %s.test1 (
						  c1 INT NOT NULL AUTO_INCREMENT,
						  c2 LONGBLOB,
						  c3 char(200),
						  PRIMARY KEY (c1)
						)
						ENGINE = %s;
					", $database, $engine);
				
		mysql_query($query, $mysql)
			or mysql_error_and_die("Query Failed: $query");
			
		$query = sprintf("CREATE TABLE %s.test2 (
						  c1 INT NOT NULL AUTO_INCREMENT,
						  c2 LONGBLOB,
						  c3 char(200),
						  PRIMARY KEY (c1)
						)
						ENGINE = %s;
					", $database, $engine);
				
		mysql_query($query, $mysql)
			or mysql_error_and_die("Query Failed: $query");
			
			
	}
	
	//------------------------------------------------------
	function init_load_test($mysql, $engine, $database)
	{
		mysql_query("Drop database $database;");
			
		mysql_query("Create database $database;");

		mysql_query("Use $database;")
			or mysql_error_and_die("Use $database; failed\n");
		
		global $s3_server;
		
		if (! empty($s3_server)) 
			set_cloud_storage();
		
		//--------------------
		for ($i = 1; $i < 4 ; $i++) {
			$query = sprintf("CREATE TABLE btest%d (
						  id INT NOT NULL AUTO_INCREMENT,
						  data LONGBLOB,
						  name char(200),
						  size INT,
						  PRIMARY KEY (id)
						)
						ENGINE = %s;
					", $i, $engine);

			if (mysql_query($query) == FALSE) {
					mysql_error_and_die("Failed: $query\n" );
			}

		}

		$query = "insert into pbms_metadata_header values(\"Name\")";
		if (mysql_query($query) == FALSE) {
			mysql_error_and_die("Failed: $query\n" );
		}
	
	}
	
	//------------------------------------------------------
	function dump_pbms_reference($mysql)
	{
		$query = "select Table_name, Blob_id,  Blob_url from pbms_reference;" ;
		$result = mysql_query($query, $mysql)
			or mysql_error_and_die("Query Failed: $query");
		
		$row = mysql_fetch_assoc($result)
			or mysql_error_and_die("No row was returned: $query");
		
		print "\n=========================================\n";
		while ($row = mysql_fetch_assoc($result)) {
			$ref = $row['Blob_url'];
			printf("%s |  %d | %s\n",  $row['Table_name'], $row['Blob_id'], $row['Blob_url']);
		}
		$query = sprintf ("select Blob_id from pbms_reference where Blob_url = '%s';", $ref) ;
		$result = mysql_query($query, $mysql)
			or mysql_error_and_die("Query Failed: $query");

//printf("mysql_num_rows(): %d\n", mysql_num_rows($result));
//print "$query\n";
		print "=========================================\n";
		
		return $query;
	}
	
	//------------------------------------------------------
	function getBlobID($id, $table, $col, $mysql)
	{
		//print "getBlobID(mysql, $id, $table, $col)\n";
		$query = sprintf ("select c1, %s from %s where c1 = %d;", $col, $table, $id) ;
		$result = mysql_query($query, $mysql)
			or mysql_error_and_die("Query Failed: $query");
		
		$row = mysql_fetch_array($result)
			or mysql_error_and_die("No row was returned: $query");

		$ref = $row[1];
		
		mysql_free_result($result);
		
	//dump_pbms_reference($mysql);
		$query = sprintf ("select Blob_id from pbms_reference where Blob_url = '%s';", $ref) ;
		$result = mysql_query($query, $mysql)
			or mysql_error_and_die("Query Failed: $query\n");

		if (mysql_num_rows($result) != 1)
			die("Unexpected number of rows: $query\n");
			
		$row = mysql_fetch_assoc($result);

		$blob_id = $row['Blob_id'];
		mysql_free_result($result);

		return $blob_id;
	}

	//------------------------------------------------------
	function getReferencedBlobCount($mysql, $table)
	{
		$query = sprintf ("select count(*) from pbms_reference where Table_name = '%s' and Deletion_time IS NULL;", $table) ;
		$result = mysql_query($query, $mysql)
			or mysql_error_and_die("Query Failed: $query");
			
		$row = mysql_fetch_row($result);
		mysql_free_result($result);
		
		return $row[0];
	}
	
	//------------------------------------------------------
	function testBlobStatus($mysql, $id, $table, $expect_null)
	{
		//print "testBlobStatus(mysql, $id, $table, $expect_null)\n";
		
		$try_again = TRUE;
		while (TRUE) {
			$query = sprintf ("select Blob_url, Deletion_time from pbms_reference where Table_name = '%s' and Blob_id = %d;", $table, $id) ;
			$result = mysql_query($query, $mysql)
				or mysql_error_and_die("Query Failed: $query");

			if (mysql_num_rows($result) != 1)
				die("Unexpected number of rows: $query\n");
				
			$row = mysql_fetch_assoc($result);
			mysql_free_result($result);
				
			if (($expect_null == TRUE) and ($row['Deletion_time'] != NULL))
				$msg = "Null Deletion_time expected but non NULL returned: \n$query\n";
			elseif (($expect_null == FALSE) and ($row['Deletion_time'] == NULL))
				$msg = "An unexpects NULL Deletion_time returned: \n$query\n";
			else
				return;
			
			if ($try_again)
				sleep(2); // Give the PBMS transaction manager some time to process the transactions.
			else
				die($msg);
				
			$try_again = FALSE;
		}
		
	}
	

?>
